// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

library haptic_feedback_mojom;

import 'dart:async';

import 'package:mojo/bindings.dart' as bindings;
import 'package:mojo/core.dart' as core;



class _HapticFeedbackVibrateParams extends bindings.Struct {
  static const List<bindings.StructDataHeader> kVersions = const [
    const bindings.StructDataHeader(8, 0)
  ];

  _HapticFeedbackVibrateParams() : super(kVersions.last.size);

  static _HapticFeedbackVibrateParams deserialize(bindings.Message message) {
    var decoder = new bindings.Decoder(message);
    var result = decode(decoder);
    if (decoder.excessHandles != null) {
      decoder.excessHandles.forEach((h) => h.close());
    }
    return result;
  }

  static _HapticFeedbackVibrateParams decode(bindings.Decoder decoder0) {
    if (decoder0 == null) {
      return null;
    }
    _HapticFeedbackVibrateParams result = new _HapticFeedbackVibrateParams();

    var mainDataHeader = decoder0.decodeStructDataHeader();
    if (mainDataHeader.version <= kVersions.last.version) {
      // Scan in reverse order to optimize for more recent versions.
      for (int i = kVersions.length - 1; i >= 0; --i) {
        if (mainDataHeader.version >= kVersions[i].version) {
          if (mainDataHeader.size == kVersions[i].size) {
            // Found a match.
            break;
          }
          throw new bindings.MojoCodecError(
              'Header size doesn\'t correspond to known version size.');
        }
      }
    } else if (mainDataHeader.size < kVersions.last.size) {
      throw new bindings.MojoCodecError(
        'Message newer than the last known version cannot be shorter than '
        'required by the last known version.');
    }
    return result;
  }

  void encode(bindings.Encoder encoder) {
    encoder.getStructEncoderAtOffset(kVersions.last);
  }

  String toString() {
    return "_HapticFeedbackVibrateParams("")";
  }

  Map toJson() {
    Map map = new Map();
    return map;
  }
}


class HapticFeedbackVibrateResponseParams extends bindings.Struct {
  static const List<bindings.StructDataHeader> kVersions = const [
    const bindings.StructDataHeader(16, 0)
  ];
  bool success = false;

  HapticFeedbackVibrateResponseParams() : super(kVersions.last.size);

  static HapticFeedbackVibrateResponseParams deserialize(bindings.Message message) {
    var decoder = new bindings.Decoder(message);
    var result = decode(decoder);
    if (decoder.excessHandles != null) {
      decoder.excessHandles.forEach((h) => h.close());
    }
    return result;
  }

  static HapticFeedbackVibrateResponseParams decode(bindings.Decoder decoder0) {
    if (decoder0 == null) {
      return null;
    }
    HapticFeedbackVibrateResponseParams result = new HapticFeedbackVibrateResponseParams();

    var mainDataHeader = decoder0.decodeStructDataHeader();
    if (mainDataHeader.version <= kVersions.last.version) {
      // Scan in reverse order to optimize for more recent versions.
      for (int i = kVersions.length - 1; i >= 0; --i) {
        if (mainDataHeader.version >= kVersions[i].version) {
          if (mainDataHeader.size == kVersions[i].size) {
            // Found a match.
            break;
          }
          throw new bindings.MojoCodecError(
              'Header size doesn\'t correspond to known version size.');
        }
      }
    } else if (mainDataHeader.size < kVersions.last.size) {
      throw new bindings.MojoCodecError(
        'Message newer than the last known version cannot be shorter than '
        'required by the last known version.');
    }
    if (mainDataHeader.version >= 0) {
      
      result.success = decoder0.decodeBool(8, 0);
    }
    return result;
  }

  void encode(bindings.Encoder encoder) {
    var encoder0 = encoder.getStructEncoderAtOffset(kVersions.last);
    
    encoder0.encodeBool(success, 8, 0);
  }

  String toString() {
    return "HapticFeedbackVibrateResponseParams("
           "success: $success" ")";
  }

  Map toJson() {
    Map map = new Map();
    map["success"] = success;
    return map;
  }
}

const int _HapticFeedback_vibrateName = 0;

abstract class HapticFeedback {
  static const String serviceName = "flutter::platform::HapticFeedback";
  dynamic vibrate([Function responseFactory = null]);
}


class _HapticFeedbackProxyImpl extends bindings.Proxy {
  _HapticFeedbackProxyImpl.fromEndpoint(
      core.MojoMessagePipeEndpoint endpoint) : super.fromEndpoint(endpoint);

  _HapticFeedbackProxyImpl.fromHandle(core.MojoHandle handle) :
      super.fromHandle(handle);

  _HapticFeedbackProxyImpl.unbound() : super.unbound();

  static _HapticFeedbackProxyImpl newFromEndpoint(
      core.MojoMessagePipeEndpoint endpoint) {
    assert(endpoint.setDescription("For _HapticFeedbackProxyImpl"));
    return new _HapticFeedbackProxyImpl.fromEndpoint(endpoint);
  }

  void handleResponse(bindings.ServiceMessage message) {
    switch (message.header.type) {
      case _HapticFeedback_vibrateName:
        var r = HapticFeedbackVibrateResponseParams.deserialize(
            message.payload);
        if (!message.header.hasRequestId) {
          proxyError("Expected a message with a valid request Id.");
          return;
        }
        Completer c = completerMap[message.header.requestId];
        if (c == null) {
          proxyError(
              "Message had unknown request Id: ${message.header.requestId}");
          return;
        }
        completerMap.remove(message.header.requestId);
        if (c.isCompleted) {
          proxyError("Response completer already completed");
          return;
        }
        c.complete(r);
        break;
      default:
        proxyError("Unexpected message type: ${message.header.type}");
        close(immediate: true);
        break;
    }
  }

  String toString() {
    var superString = super.toString();
    return "_HapticFeedbackProxyImpl($superString)";
  }
}


class _HapticFeedbackProxyCalls implements HapticFeedback {
  _HapticFeedbackProxyImpl _proxyImpl;

  _HapticFeedbackProxyCalls(this._proxyImpl);
    dynamic vibrate([Function responseFactory = null]) {
      var params = new _HapticFeedbackVibrateParams();
      return _proxyImpl.sendMessageWithRequestId(
          params,
          _HapticFeedback_vibrateName,
          -1,
          bindings.MessageHeader.kMessageExpectsResponse);
    }
}


class HapticFeedbackProxy implements bindings.ProxyBase {
  final bindings.Proxy impl;
  HapticFeedback ptr;

  HapticFeedbackProxy(_HapticFeedbackProxyImpl proxyImpl) :
      impl = proxyImpl,
      ptr = new _HapticFeedbackProxyCalls(proxyImpl);

  HapticFeedbackProxy.fromEndpoint(
      core.MojoMessagePipeEndpoint endpoint) :
      impl = new _HapticFeedbackProxyImpl.fromEndpoint(endpoint) {
    ptr = new _HapticFeedbackProxyCalls(impl);
  }

  HapticFeedbackProxy.fromHandle(core.MojoHandle handle) :
      impl = new _HapticFeedbackProxyImpl.fromHandle(handle) {
    ptr = new _HapticFeedbackProxyCalls(impl);
  }

  HapticFeedbackProxy.unbound() :
      impl = new _HapticFeedbackProxyImpl.unbound() {
    ptr = new _HapticFeedbackProxyCalls(impl);
  }

  factory HapticFeedbackProxy.connectToService(
      bindings.ServiceConnector s, String url, [String serviceName]) {
    HapticFeedbackProxy p = new HapticFeedbackProxy.unbound();
    s.connectToService(url, p, serviceName);
    return p;
  }

  static HapticFeedbackProxy newFromEndpoint(
      core.MojoMessagePipeEndpoint endpoint) {
    assert(endpoint.setDescription("For HapticFeedbackProxy"));
    return new HapticFeedbackProxy.fromEndpoint(endpoint);
  }

  String get serviceName => HapticFeedback.serviceName;

  Future close({bool immediate: false}) => impl.close(immediate: immediate);

  Future responseOrError(Future f) => impl.responseOrError(f);

  Future get errorFuture => impl.errorFuture;

  int get version => impl.version;

  Future<int> queryVersion() => impl.queryVersion();

  void requireVersion(int requiredVersion) {
    impl.requireVersion(requiredVersion);
  }

  String toString() {
    return "HapticFeedbackProxy($impl)";
  }
}


class HapticFeedbackStub extends bindings.Stub {
  HapticFeedback _impl = null;

  HapticFeedbackStub.fromEndpoint(
      core.MojoMessagePipeEndpoint endpoint, [this._impl])
      : super.fromEndpoint(endpoint);

  HapticFeedbackStub.fromHandle(core.MojoHandle handle, [this._impl])
      : super.fromHandle(handle);

  HapticFeedbackStub.unbound() : super.unbound();

  static HapticFeedbackStub newFromEndpoint(
      core.MojoMessagePipeEndpoint endpoint) {
    assert(endpoint.setDescription("For HapticFeedbackStub"));
    return new HapticFeedbackStub.fromEndpoint(endpoint);
  }


  HapticFeedbackVibrateResponseParams _HapticFeedbackVibrateResponseParamsFactory(bool success) {
    var mojo_factory_result = new HapticFeedbackVibrateResponseParams();
    mojo_factory_result.success = success;
    return mojo_factory_result;
  }

  dynamic handleMessage(bindings.ServiceMessage message) {
    if (bindings.ControlMessageHandler.isControlMessage(message)) {
      return bindings.ControlMessageHandler.handleMessage(this,
                                                          0,
                                                          message);
    }
    assert(_impl != null);
    switch (message.header.type) {
      case _HapticFeedback_vibrateName:
        var params = _HapticFeedbackVibrateParams.deserialize(
            message.payload);
        var response = _impl.vibrate(_HapticFeedbackVibrateResponseParamsFactory);
        if (response is Future) {
          return response.then((response) {
            if (response != null) {
              return buildResponseWithId(
                  response,
                  _HapticFeedback_vibrateName,
                  message.header.requestId,
                  bindings.MessageHeader.kMessageIsResponse);
            }
          });
        } else if (response != null) {
          return buildResponseWithId(
              response,
              _HapticFeedback_vibrateName,
              message.header.requestId,
              bindings.MessageHeader.kMessageIsResponse);
        }
        break;
      default:
        throw new bindings.MojoCodecError("Unexpected message name");
        break;
    }
    return null;
  }

  HapticFeedback get impl => _impl;
  set impl(HapticFeedback d) {
    assert(_impl == null);
    _impl = d;
  }

  String toString() {
    var superString = super.toString();
    return "HapticFeedbackStub($superString)";
  }

  int get version => 0;
}


