// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

library path_provider_mojom;

import 'dart:async';

import 'package:mojo/bindings.dart' as bindings;
import 'package:mojo/core.dart' as core;



class _PathProviderTemporaryDirectoryParams extends bindings.Struct {
  static const List<bindings.StructDataHeader> kVersions = const [
    const bindings.StructDataHeader(8, 0)
  ];

  _PathProviderTemporaryDirectoryParams() : super(kVersions.last.size);

  static _PathProviderTemporaryDirectoryParams deserialize(bindings.Message message) {
    var decoder = new bindings.Decoder(message);
    var result = decode(decoder);
    if (decoder.excessHandles != null) {
      decoder.excessHandles.forEach((h) => h.close());
    }
    return result;
  }

  static _PathProviderTemporaryDirectoryParams decode(bindings.Decoder decoder0) {
    if (decoder0 == null) {
      return null;
    }
    _PathProviderTemporaryDirectoryParams result = new _PathProviderTemporaryDirectoryParams();

    var mainDataHeader = decoder0.decodeStructDataHeader();
    if (mainDataHeader.version <= kVersions.last.version) {
      // Scan in reverse order to optimize for more recent versions.
      for (int i = kVersions.length - 1; i >= 0; --i) {
        if (mainDataHeader.version >= kVersions[i].version) {
          if (mainDataHeader.size == kVersions[i].size) {
            // Found a match.
            break;
          }
          throw new bindings.MojoCodecError(
              'Header size doesn\'t correspond to known version size.');
        }
      }
    } else if (mainDataHeader.size < kVersions.last.size) {
      throw new bindings.MojoCodecError(
        'Message newer than the last known version cannot be shorter than '
        'required by the last known version.');
    }
    return result;
  }

  void encode(bindings.Encoder encoder) {
    encoder.getStructEncoderAtOffset(kVersions.last);
  }

  String toString() {
    return "_PathProviderTemporaryDirectoryParams("")";
  }

  Map toJson() {
    Map map = new Map();
    return map;
  }
}


class PathProviderTemporaryDirectoryResponseParams extends bindings.Struct {
  static const List<bindings.StructDataHeader> kVersions = const [
    const bindings.StructDataHeader(16, 0)
  ];
  String path = null;

  PathProviderTemporaryDirectoryResponseParams() : super(kVersions.last.size);

  static PathProviderTemporaryDirectoryResponseParams deserialize(bindings.Message message) {
    var decoder = new bindings.Decoder(message);
    var result = decode(decoder);
    if (decoder.excessHandles != null) {
      decoder.excessHandles.forEach((h) => h.close());
    }
    return result;
  }

  static PathProviderTemporaryDirectoryResponseParams decode(bindings.Decoder decoder0) {
    if (decoder0 == null) {
      return null;
    }
    PathProviderTemporaryDirectoryResponseParams result = new PathProviderTemporaryDirectoryResponseParams();

    var mainDataHeader = decoder0.decodeStructDataHeader();
    if (mainDataHeader.version <= kVersions.last.version) {
      // Scan in reverse order to optimize for more recent versions.
      for (int i = kVersions.length - 1; i >= 0; --i) {
        if (mainDataHeader.version >= kVersions[i].version) {
          if (mainDataHeader.size == kVersions[i].size) {
            // Found a match.
            break;
          }
          throw new bindings.MojoCodecError(
              'Header size doesn\'t correspond to known version size.');
        }
      }
    } else if (mainDataHeader.size < kVersions.last.size) {
      throw new bindings.MojoCodecError(
        'Message newer than the last known version cannot be shorter than '
        'required by the last known version.');
    }
    if (mainDataHeader.version >= 0) {
      
      result.path = decoder0.decodeString(8, false);
    }
    return result;
  }

  void encode(bindings.Encoder encoder) {
    var encoder0 = encoder.getStructEncoderAtOffset(kVersions.last);
    
    encoder0.encodeString(path, 8, false);
  }

  String toString() {
    return "PathProviderTemporaryDirectoryResponseParams("
           "path: $path" ")";
  }

  Map toJson() {
    Map map = new Map();
    map["path"] = path;
    return map;
  }
}


class _PathProviderApplicationDocumentsDirectoryParams extends bindings.Struct {
  static const List<bindings.StructDataHeader> kVersions = const [
    const bindings.StructDataHeader(8, 0)
  ];

  _PathProviderApplicationDocumentsDirectoryParams() : super(kVersions.last.size);

  static _PathProviderApplicationDocumentsDirectoryParams deserialize(bindings.Message message) {
    var decoder = new bindings.Decoder(message);
    var result = decode(decoder);
    if (decoder.excessHandles != null) {
      decoder.excessHandles.forEach((h) => h.close());
    }
    return result;
  }

  static _PathProviderApplicationDocumentsDirectoryParams decode(bindings.Decoder decoder0) {
    if (decoder0 == null) {
      return null;
    }
    _PathProviderApplicationDocumentsDirectoryParams result = new _PathProviderApplicationDocumentsDirectoryParams();

    var mainDataHeader = decoder0.decodeStructDataHeader();
    if (mainDataHeader.version <= kVersions.last.version) {
      // Scan in reverse order to optimize for more recent versions.
      for (int i = kVersions.length - 1; i >= 0; --i) {
        if (mainDataHeader.version >= kVersions[i].version) {
          if (mainDataHeader.size == kVersions[i].size) {
            // Found a match.
            break;
          }
          throw new bindings.MojoCodecError(
              'Header size doesn\'t correspond to known version size.');
        }
      }
    } else if (mainDataHeader.size < kVersions.last.size) {
      throw new bindings.MojoCodecError(
        'Message newer than the last known version cannot be shorter than '
        'required by the last known version.');
    }
    return result;
  }

  void encode(bindings.Encoder encoder) {
    encoder.getStructEncoderAtOffset(kVersions.last);
  }

  String toString() {
    return "_PathProviderApplicationDocumentsDirectoryParams("")";
  }

  Map toJson() {
    Map map = new Map();
    return map;
  }
}


class PathProviderApplicationDocumentsDirectoryResponseParams extends bindings.Struct {
  static const List<bindings.StructDataHeader> kVersions = const [
    const bindings.StructDataHeader(16, 0)
  ];
  String path = null;

  PathProviderApplicationDocumentsDirectoryResponseParams() : super(kVersions.last.size);

  static PathProviderApplicationDocumentsDirectoryResponseParams deserialize(bindings.Message message) {
    var decoder = new bindings.Decoder(message);
    var result = decode(decoder);
    if (decoder.excessHandles != null) {
      decoder.excessHandles.forEach((h) => h.close());
    }
    return result;
  }

  static PathProviderApplicationDocumentsDirectoryResponseParams decode(bindings.Decoder decoder0) {
    if (decoder0 == null) {
      return null;
    }
    PathProviderApplicationDocumentsDirectoryResponseParams result = new PathProviderApplicationDocumentsDirectoryResponseParams();

    var mainDataHeader = decoder0.decodeStructDataHeader();
    if (mainDataHeader.version <= kVersions.last.version) {
      // Scan in reverse order to optimize for more recent versions.
      for (int i = kVersions.length - 1; i >= 0; --i) {
        if (mainDataHeader.version >= kVersions[i].version) {
          if (mainDataHeader.size == kVersions[i].size) {
            // Found a match.
            break;
          }
          throw new bindings.MojoCodecError(
              'Header size doesn\'t correspond to known version size.');
        }
      }
    } else if (mainDataHeader.size < kVersions.last.size) {
      throw new bindings.MojoCodecError(
        'Message newer than the last known version cannot be shorter than '
        'required by the last known version.');
    }
    if (mainDataHeader.version >= 0) {
      
      result.path = decoder0.decodeString(8, false);
    }
    return result;
  }

  void encode(bindings.Encoder encoder) {
    var encoder0 = encoder.getStructEncoderAtOffset(kVersions.last);
    
    encoder0.encodeString(path, 8, false);
  }

  String toString() {
    return "PathProviderApplicationDocumentsDirectoryResponseParams("
           "path: $path" ")";
  }

  Map toJson() {
    Map map = new Map();
    map["path"] = path;
    return map;
  }
}

const int _PathProvider_temporaryDirectoryName = 0;
const int _PathProvider_applicationDocumentsDirectoryName = 1;

abstract class PathProvider {
  static const String serviceName = "flutter::platform::PathProvider";
  dynamic temporaryDirectory([Function responseFactory = null]);
  dynamic applicationDocumentsDirectory([Function responseFactory = null]);
}


class _PathProviderProxyImpl extends bindings.Proxy {
  _PathProviderProxyImpl.fromEndpoint(
      core.MojoMessagePipeEndpoint endpoint) : super.fromEndpoint(endpoint);

  _PathProviderProxyImpl.fromHandle(core.MojoHandle handle) :
      super.fromHandle(handle);

  _PathProviderProxyImpl.unbound() : super.unbound();

  static _PathProviderProxyImpl newFromEndpoint(
      core.MojoMessagePipeEndpoint endpoint) {
    assert(endpoint.setDescription("For _PathProviderProxyImpl"));
    return new _PathProviderProxyImpl.fromEndpoint(endpoint);
  }

  void handleResponse(bindings.ServiceMessage message) {
    switch (message.header.type) {
      case _PathProvider_temporaryDirectoryName:
        var r = PathProviderTemporaryDirectoryResponseParams.deserialize(
            message.payload);
        if (!message.header.hasRequestId) {
          proxyError("Expected a message with a valid request Id.");
          return;
        }
        Completer c = completerMap[message.header.requestId];
        if (c == null) {
          proxyError(
              "Message had unknown request Id: ${message.header.requestId}");
          return;
        }
        completerMap.remove(message.header.requestId);
        if (c.isCompleted) {
          proxyError("Response completer already completed");
          return;
        }
        c.complete(r);
        break;
      case _PathProvider_applicationDocumentsDirectoryName:
        var r = PathProviderApplicationDocumentsDirectoryResponseParams.deserialize(
            message.payload);
        if (!message.header.hasRequestId) {
          proxyError("Expected a message with a valid request Id.");
          return;
        }
        Completer c = completerMap[message.header.requestId];
        if (c == null) {
          proxyError(
              "Message had unknown request Id: ${message.header.requestId}");
          return;
        }
        completerMap.remove(message.header.requestId);
        if (c.isCompleted) {
          proxyError("Response completer already completed");
          return;
        }
        c.complete(r);
        break;
      default:
        proxyError("Unexpected message type: ${message.header.type}");
        close(immediate: true);
        break;
    }
  }

  String toString() {
    var superString = super.toString();
    return "_PathProviderProxyImpl($superString)";
  }
}


class _PathProviderProxyCalls implements PathProvider {
  _PathProviderProxyImpl _proxyImpl;

  _PathProviderProxyCalls(this._proxyImpl);
    dynamic temporaryDirectory([Function responseFactory = null]) {
      var params = new _PathProviderTemporaryDirectoryParams();
      return _proxyImpl.sendMessageWithRequestId(
          params,
          _PathProvider_temporaryDirectoryName,
          -1,
          bindings.MessageHeader.kMessageExpectsResponse);
    }
    dynamic applicationDocumentsDirectory([Function responseFactory = null]) {
      var params = new _PathProviderApplicationDocumentsDirectoryParams();
      return _proxyImpl.sendMessageWithRequestId(
          params,
          _PathProvider_applicationDocumentsDirectoryName,
          -1,
          bindings.MessageHeader.kMessageExpectsResponse);
    }
}


class PathProviderProxy implements bindings.ProxyBase {
  final bindings.Proxy impl;
  PathProvider ptr;

  PathProviderProxy(_PathProviderProxyImpl proxyImpl) :
      impl = proxyImpl,
      ptr = new _PathProviderProxyCalls(proxyImpl);

  PathProviderProxy.fromEndpoint(
      core.MojoMessagePipeEndpoint endpoint) :
      impl = new _PathProviderProxyImpl.fromEndpoint(endpoint) {
    ptr = new _PathProviderProxyCalls(impl);
  }

  PathProviderProxy.fromHandle(core.MojoHandle handle) :
      impl = new _PathProviderProxyImpl.fromHandle(handle) {
    ptr = new _PathProviderProxyCalls(impl);
  }

  PathProviderProxy.unbound() :
      impl = new _PathProviderProxyImpl.unbound() {
    ptr = new _PathProviderProxyCalls(impl);
  }

  factory PathProviderProxy.connectToService(
      bindings.ServiceConnector s, String url, [String serviceName]) {
    PathProviderProxy p = new PathProviderProxy.unbound();
    s.connectToService(url, p, serviceName);
    return p;
  }

  static PathProviderProxy newFromEndpoint(
      core.MojoMessagePipeEndpoint endpoint) {
    assert(endpoint.setDescription("For PathProviderProxy"));
    return new PathProviderProxy.fromEndpoint(endpoint);
  }

  String get serviceName => PathProvider.serviceName;

  Future close({bool immediate: false}) => impl.close(immediate: immediate);

  Future responseOrError(Future f) => impl.responseOrError(f);

  Future get errorFuture => impl.errorFuture;

  int get version => impl.version;

  Future<int> queryVersion() => impl.queryVersion();

  void requireVersion(int requiredVersion) {
    impl.requireVersion(requiredVersion);
  }

  String toString() {
    return "PathProviderProxy($impl)";
  }
}


class PathProviderStub extends bindings.Stub {
  PathProvider _impl = null;

  PathProviderStub.fromEndpoint(
      core.MojoMessagePipeEndpoint endpoint, [this._impl])
      : super.fromEndpoint(endpoint);

  PathProviderStub.fromHandle(core.MojoHandle handle, [this._impl])
      : super.fromHandle(handle);

  PathProviderStub.unbound() : super.unbound();

  static PathProviderStub newFromEndpoint(
      core.MojoMessagePipeEndpoint endpoint) {
    assert(endpoint.setDescription("For PathProviderStub"));
    return new PathProviderStub.fromEndpoint(endpoint);
  }


  PathProviderTemporaryDirectoryResponseParams _PathProviderTemporaryDirectoryResponseParamsFactory(String path) {
    var mojo_factory_result = new PathProviderTemporaryDirectoryResponseParams();
    mojo_factory_result.path = path;
    return mojo_factory_result;
  }
  PathProviderApplicationDocumentsDirectoryResponseParams _PathProviderApplicationDocumentsDirectoryResponseParamsFactory(String path) {
    var mojo_factory_result = new PathProviderApplicationDocumentsDirectoryResponseParams();
    mojo_factory_result.path = path;
    return mojo_factory_result;
  }

  dynamic handleMessage(bindings.ServiceMessage message) {
    if (bindings.ControlMessageHandler.isControlMessage(message)) {
      return bindings.ControlMessageHandler.handleMessage(this,
                                                          0,
                                                          message);
    }
    assert(_impl != null);
    switch (message.header.type) {
      case _PathProvider_temporaryDirectoryName:
        var params = _PathProviderTemporaryDirectoryParams.deserialize(
            message.payload);
        var response = _impl.temporaryDirectory(_PathProviderTemporaryDirectoryResponseParamsFactory);
        if (response is Future) {
          return response.then((response) {
            if (response != null) {
              return buildResponseWithId(
                  response,
                  _PathProvider_temporaryDirectoryName,
                  message.header.requestId,
                  bindings.MessageHeader.kMessageIsResponse);
            }
          });
        } else if (response != null) {
          return buildResponseWithId(
              response,
              _PathProvider_temporaryDirectoryName,
              message.header.requestId,
              bindings.MessageHeader.kMessageIsResponse);
        }
        break;
      case _PathProvider_applicationDocumentsDirectoryName:
        var params = _PathProviderApplicationDocumentsDirectoryParams.deserialize(
            message.payload);
        var response = _impl.applicationDocumentsDirectory(_PathProviderApplicationDocumentsDirectoryResponseParamsFactory);
        if (response is Future) {
          return response.then((response) {
            if (response != null) {
              return buildResponseWithId(
                  response,
                  _PathProvider_applicationDocumentsDirectoryName,
                  message.header.requestId,
                  bindings.MessageHeader.kMessageIsResponse);
            }
          });
        } else if (response != null) {
          return buildResponseWithId(
              response,
              _PathProvider_applicationDocumentsDirectoryName,
              message.header.requestId,
              bindings.MessageHeader.kMessageIsResponse);
        }
        break;
      default:
        throw new bindings.MojoCodecError("Unexpected message name");
        break;
    }
    return null;
  }

  PathProvider get impl => _impl;
  set impl(PathProvider d) {
    assert(_impl == null);
    _impl = d;
  }

  String toString() {
    var superString = super.toString();
    return "PathProviderStub($superString)";
  }

  int get version => 0;
}


